From 05874ff181e8f4d36f4d0f83ae11104be95b8000 Mon Sep 17 00:00:00 2001
From: Hannes Domani <ssbssa@yahoo.de>
Date: Thu, 5 Mar 2015 19:38:12 +0100
Subject: [PATCH] portable windows build

---
 modules/gui/qt4/qt4.cpp |  9 +++++++++
 src/win32/dirs.c        | 15 +++++++++++++++
 2 files changed, 24 insertions(+)

diff --git a/modules/gui/qt4/qt4.cpp b/modules/gui/qt4/qt4.cpp
index e8b841d..44fa19e 100644
--- a/modules/gui/qt4/qt4.cpp
+++ b/modules/gui/qt4/qt4.cpp
@@ -481,6 +481,15 @@ static void *Thread( void *obj )
 
 
     /* All the settings are in the .conf/.ini style */
+#ifdef _WIN32
+    char *cConfigDir = config_GetUserDir( VLC_CONFIG_DIR );
+    QString configDir = cConfigDir;
+    free( cConfigDir );
+    if( configDir.endsWith( "\\vlc" ) )
+        configDir.chop( 4 ); /* the "\vlc" dir is added again by QSettings */
+    QSettings::setPath( QSettings::IniFormat, QSettings::UserScope, configDir );
+#endif
+
     p_intf->p_sys->mainSettings = new QSettings(
 #ifdef _WIN32
             QSettings::IniFormat,
diff --git a/src/win32/dirs.c b/src/win32/dirs.c
index fbb48b6..bd2d816 100644
--- a/src/win32/dirs.c
+++ b/src/win32/dirs.c
@@ -87,6 +87,21 @@ static char *config_GetShellDir (int csidl)
 
 static char *config_GetAppDir (void)
 {
+    /* if portable directory exists, use it */
+    TCHAR path[MAX_PATH];
+    if (GetModuleFileName (NULL, path, MAX_PATH))
+    {
+        TCHAR *lastDir = _tcsrchr (path, '\\');
+        if (lastDir && !_tcsicmp (lastDir + 1, TEXT("vlc.exe")))
+        {
+            _tcscpy (lastDir + 1, TEXT("portable"));
+            DWORD attrib = GetFileAttributes (path);
+            if (attrib != INVALID_FILE_ATTRIBUTES &&
+                    (attrib & FILE_ATTRIBUTE_DIRECTORY))
+                return FromT (path);
+        }
+    }
+
     char *psz_dir;
     char *psz_parent = config_GetShellDir (CSIDL_APPDATA);
 
-- 
1.9.4.msysgit.2

